#include "xfwish.h"

/*
includes code from sula v0.1.81 (etc_cb.c)
*/

typedef struct {
        FL_FORM *confirm;
        void *vdata;
        long ldata;
        FL_OBJECT *mainbox;
        FL_OBJECT *boxes;
        FL_OBJECT *yes;
        FL_OBJECT *no;
        FL_OBJECT *icon;
        FL_OBJECT *timer;
} FD_confirm;
static void timer2_cb(FL_OBJECT *, long);
char *message=NULL;
char *pixmapfile=NULL;
static FD_confirm *create_form_confirm(void)
{
  FL_OBJECT *obj;
  FD_confirm *fdui = (FD_confirm *) fl_calloc(1, sizeof(*fdui));
  char **xpm;
  char shortcut[5];
    int lw=0, lh=0, new_w,new_h, w,h;
    int delta, ww,hh;

  if(!pixmapfile || get_pixmap_dimension(pixmapfile, &w, &h)){
  if(information){
  	#include "info.xpm"
	xpm=info_xpm;
	w=50; h=50;
	}
 else if(question){
	#include "question.xpm"
	xpm = question_xpm;
	w=23; h=33;
	}
else if(warning){
#include "warning.xpm"
	xpm = warning2_xpm;
	w=50; h=41;
	}
}
fl_get_string_dimension(fontstyle, fontsize, yeslabel, strlen(yeslabel),&ww, &hh);
if(question){
   	fl_get_string_dimension(fontstyle, fontsize, nolabel, strlen(nolabel),&lw, &lh);
	if(lw>ww) ww=lw;
	if(lh>hh) hh=lh;
	lw=lh=0;
} 
ww*=1.5; hh*=1.8;
new_h=h+5+8+hh+5;
if(question) new_w=2*ww+10+10+65;
else new_w=ww+10+65;
if(timeout) new_w+=50+10;
/*if(new_w<h) new_w=h;*/
message=buildstr(message);
  if(message){
  	fl_get_string_dimension(labelfontstyle, labelfontsize, message, strlen(message),
	&lw, &lh);
  }
  if(lh)
  	if(0.8*lh>10) lh+=10;
	else lh *=1.8;
  if(lw)
     if(0.5*lw>10) lw+=10;
     else lw *= 1.5;
  if(lw>new_w) new_w=lw;
  new_h+=lh+(lh>0?5:0);
  if(width<new_w) width=new_w;
  if(height<new_h) height=new_h;
  delta=width>height?0.02*width:0.02*height;
  if(delta>10) delta=10;
  width+=2*delta; height+=2*delta;


  
  fdui->confirm = fl_bgn_form(FL_NO_BOX,width,height);
  fdui->mainbox = obj = fl_add_box(FL_UP_BOX,0,0,width,height,"");
  fl_set_object_color(obj,bgcolor,bgcolor);
  #if 0
  obj = fl_add_frame(FL_ENGRAVED_FRAME,5,5,290,160,"");
    fl_set_object_color(obj,FL_COL1,FL_COL1);
  #endif
  fdui->icon = obj = fl_add_pixmap(FL_NORMAL_PIXMAP,(width-w)/2,delta,w,h,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    if(pixmapfile) fl_set_pixmap_file(obj, pixmapfile);
    else
    fl_set_pixmap_data(obj, xpm);
    new_h=delta+h+5;
  if(message){
	
	obj =fl_add_text(FL_NORMAL_TEXT,delta,new_h,width-2*delta,lh,message);
	 fl_set_object_boxtype(obj,labelboxtype);
    	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lsize(obj,labelfontsize);
    fl_set_object_lstyle(obj,labelfontstyle);
    fl_set_object_lcolor(obj,fgcolor);
    new_h+=lh+5; /* next y pos*/
     }
  obj = fl_add_text(FL_NORMAL_TEXT,delta,new_h,width-2*delta,8,"@DnLine");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  new_h+=8+5;
  fdui->boxes = fl_bgn_group();
  new_w=question?((width-(delta+ww)*2-20-30)/2):(width-ww-2*delta-(timeout?50:0))/2;
  fdui->yes = obj = fl_add_button(FL_NORMAL_BUTTON,
  new_w,new_h,ww,hh,yeslabel);
    sprintf(shortcut,"#%c", *yeslabel); 
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_color(obj,upcolor, downcolor);
    fl_set_button_shortcut(obj,shortcut,1);
    fl_set_object_boxtype(obj,boxtype);
    new_w+=ww;
    if(question){
  fdui->no = obj = fl_add_button(FL_NORMAL_BUTTON,new_w+25,new_h,ww,hh,nolabel);
    if(*yeslabel!=*nolabel) sprintf(shortcut,"#%c", *nolabel);
    else sprintf(shortcut,"#%c", isupper(*nolabel)?tolower(*nolabel):toupper(*nolabel));
    fl_set_button_shortcut(obj,shortcut,1);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_color(obj,upcolor, downcolor);
    fl_set_object_boxtype(obj,boxtype);
    new_w+=ww;
    }
  fl_end_group();
  fl_set_object_lsize(fdui->boxes,fontsize);
  fl_set_object_lstyle(fdui->boxes,fontstyle);
  fl_set_object_lcolor(fdui->boxes,labelcolor);
  
  if(timeout){
  	fdui->timer = obj = fl_add_timer(FL_VALUE_TIMER/*FL_NORMAL_TIMER*/,
  	width-50-10-delta, new_h+2,50,20,"");
    	fl_set_object_boxtype(obj,FL_FLAT_BOX);
    	fl_set_object_callback(obj,timer2_cb,0);
    }
  
  fl_end_form();

  fdui->confirm->fdui = fdui;

  return fdui;
}

int     confirm(const char *message, int flag)
{
	FD_confirm *form = create_form_confirm();
	FL_OBJECT *answer;
	fl_set_form_atclose(form->confirm, dont_close_win, 0);
	
	fl_show_form(form->confirm, placement, border, title);
	if (timeout)
		fl_set_timer(form->timer, timeout);
	else fl_hide_object(form->timer);
	while ((answer = fl_do_forms()) != form->yes && answer != form->no);
	fl_hide_form(form->confirm);
	fl_free_form(form->confirm);
	return answer == form->yes ? 1 : 0;
}
static void    timer2_cb(FL_OBJECT * ob, long data)
{
	fl_trigger_object(information|| warning?
	((FD_confirm *) ob->form->fdui)->yes:((FD_confirm *) ob->form->fdui)->no);
}

void do_confirm(int argc, char **argv){
	char    return_label=0;

	while (1) {
		int     i, option_index = 0;
		static struct option long_options[] =
		{
			{"message", 1, 0, 'm'},
			{"question", 1, 0, 'q'},
			{"return-label", 0, 0, 'r'},
			{"pixmap", 1, 0, 'f'},
			{0, 0, 0, 0}
		};

		i = getopt_long(argc, argv, "",
				long_options, &option_index);
		if (i == -1)
			break;
		switch (i) {
		    case 'q':case 'm':
			    message = optarg;
			    break;
		    case 'r':{
			return_label=1;
			break;
			    }
		    case 'f':{
			pixmapfile = optarg;
			break;
			    }
			
		    case '?':
			    break;
		    default:
			    break;
		}		/* switch */
	}
	message=buildstr(message);
	/*if(!message) message="";*/
	if(question){
		/*if(!message) message="Confirm";*/
		if(return_label) printf("%s\n",confirm(message,1)?yeslabel:nolabel);
		else printf("%d\n",confirm(message,1)?0:1);
	}
	else{
		/*if(!message) message="Message";*/
		confirm(message,0);
	}
	exit(0);
}

