#include "xfwish.h"
static  FL_OBJECT *x, *y, *pos;
static  int  prec = 0;/* pos precision*/
static int reset_on_return=0;
static void
pos_cb(FL_OBJECT *ob, long data)
{
    switch(data){
    case 0:{
    	char str[64];
    	sprintf(str,"%.*lf",prec, fl_get_positioner_xvalue(ob));
    	fl_set_object_label(x,str);
    	sprintf(str,"%.*lf",prec,fl_get_positioner_yvalue(ob));
    	fl_set_object_label(y,str);
	if(reset_on_return)
	fl_set_timer( (FL_OBJECT *) ob->u_vdata, timeout);
    	}
	break;
   case 1:case 2:
	printf("%.*lf %.*lf\n",prec,fl_get_positioner_xvalue(pos),prec,
	fl_get_positioner_yvalue(pos)); 
	exit(0);
        
  default:break;
  }
}
void do_positioner(int argc, char **argv){
double xstep=0.0, ystep=0.0, xstart=0.0, ystart=0.0;
int delta, ww,hh;/* delta*/
float FAKTOR=1.8;
char *pixmapfile=NULL;
FL_FORM *form;
  FL_OBJECT   *ob, *ok, *cancel;
  char *p, shortcut[3];
  int lw=0, lh=0, new_w,new_h, w,h;
  reset_on_return=0;

	while (1) {
		int     i, option_index = 0;
		static struct option long_options[] =
		{
			{"pixmap", 1, 0, 'f'},
			{"label", 1, 0, 'l'},
			{"xstep",1,0,'x'},
			{"ystep",1,0,'y'},
			{"xstart",1,0,'X'},
			{"ystart",1,0,'Y'},
			{"precision", 1, 0, 'p'},
			{"reset-on-return",0,0,'r'},
			{0, 0, 0, 0}
		};
		i = getopt_long(argc, argv, "",
				long_options, &option_index);
		if (i == -1)
			break;

		switch (i) {
		    case 'f':{
			pixmapfile = optarg;
			break;
			    }
		    case 'l':
			    label = optarg;
			    break;
		    case 'x':
		    		xstep=atof(optarg);
				break;
		    case 'y':
		    		ystep=atof(optarg);
				break;
		    case 'X':
		    		xstart=atof(optarg);
				break;
		    case 'Y':
		    		ystart=atof(optarg);
				break;
		    case 'p':
			    prec = atof(optarg);
			    if(prec>31) prec=31;
			    break;
		   case 'r':
		   		reset_on_return=1;
				break;
		    case '?':
			    break;
		    default:
			    break;
		}
	}/* while */
	if(!pixmapfile){
		fprintf(stderr, "Usage: %s [options] --pixmap <file>\n", argv[0]);
		exit(-1);
	}
	if(get_pixmap_dimension(pixmapfile, &w, &h)){
		/*printf("-1 -1\n");*/
		exit(0);
	}
   fl_get_string_dimension(fontstyle, fontsize, yeslabel, strlen(yeslabel),&ww, &hh);
   fl_get_string_dimension(fontstyle, fontsize, nolabel, strlen(nolabel),&lw, &lh);
   if(lw>ww) ww=lw;
   lw=lh=0;
   ww*=1.5; hh*=1.8;
   new_h=hh*2+5+20+5; /* 4 buttons+space+timer*/
   if((h+43+5)>new_h) new_h=h+48;
   new_w=w+(ww>80?ww:80)+10; /* 10:space*/
   lw=fl_get_char_width(FL_NORMAL_STYLE, FL_NORMAL_SIZE)*(prec+10);
   if(lw>new_w) new_w=lw;
   lw=0;
  label=buildstr(label);
  if(label){
  	fl_get_string_dimension(labelfontstyle, labelfontsize, label, strlen(label),
	&lw, &lh);
  }
  if(lh)
  	if(0.8*lh>10) lh+=10;
	else lh *=1.8;
  if(lw)
     if(0.5*lw>10) lw+=10;
     else lw *= 1.5;
  if(lw>new_w) new_w=lw;
  new_h+=lh+(lh>0?5:0);
  if(width<new_w) width=new_w;
  if(height<new_h) height=new_h;
  delta=width>height?0.02*width:0.02*height;
  if(delta>10) delta=10;
  width+=2*delta; height+=2*delta;
  form = fl_bgn_form(FL_UP_BOX,width,height);
  ob = fl_add_box(FL_UP_BOX,0,0,width,height,"");
     fl_set_object_color(ob,bgcolor,bgcolor);
     #if 0
  ob = fl_add_frame(FL_ENGRAVED_FRAME,5,5,width-10,height-10,"");
    fl_set_object_color(ob,fgcolor,bgcolor);
    fl_set_object_gravity(ob, FL_East, FL_NoGravity);
    #endif
     if(label){
	
	ob=fl_add_text(FL_NORMAL_TEXT,delta,delta,width-2*delta,lh,label);
	 fl_set_object_boxtype(ob,labelboxtype);
    	fl_set_object_lalign(ob,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
	fl_set_object_lsize(ob,labelfontsize);
    fl_set_object_lstyle(ob,labelfontstyle);
    fl_set_object_lcolor(ob,fgcolor);
    new_h=delta+lh+5; /* next y pos*/
     }else new_h=delta; /* next y pos*/
     ob = fl_add_pixmap(FL_NORMAL_PIXMAP, delta, new_h, w,h, "");
     fl_set_object_resize(ob, FL_RESIZE_NONE);
     fl_set_object_boxtype(ob, FL_DOWN_BOX);
     fl_set_object_color(ob,FL_INACTIVE,bgcolor);
     fl_set_pixmap_file(ob, pixmapfile);
     fl_set_object_gravity(ob, FL_West, FL_NoGravity);
     
     pos = fl_add_positioner(FL_OVERLAY_POSITIONER,delta, new_h, w,h, "");
     fl_set_object_resize(pos, FL_RESIZE_NONE);
     fl_set_positioner_xbounds(pos,0,w);
     fl_set_positioner_ybounds(pos,0,h);
     fl_set_positioner_ystep(pos,ystep);
     fl_set_positioner_xstep(pos,xstep);
     fl_set_positioner_yvalue(pos,ystart);
     fl_set_positioner_xvalue(pos,xstart);
     fl_set_object_callback(pos,pos_cb,(long)0);
     fl_set_object_gravity(pos, FL_West, FL_NoGravity);
     x = fl_add_box(FL_DOWN_BOX,delta,new_h+h+5,lw,20,"");
     lw=fl_get_string_width(x->lstyle,
     x->lsize, "7",1)*(prec+2+(w<100?2:(w<1000?3:(w<10000?4:5))));
     fl_set_object_size(x,lw,20);
     y = fl_add_box(FL_DOWN_BOX,delta,new_h+h+5+21,lw,20,"");
     fl_set_object_lalign(x,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
     fl_set_object_lalign(y,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
     fl_set_object_color(x,FL_COL1,FL_COL1);
     fl_set_object_color(y,FL_COL1,FL_COL1);
     /*new_h+=80;*/
     ob = fl_add_timer(FL_VALUE_TIMER,width-80-delta,new_h,80,20,"");
    fl_set_object_boxtype(ob,FL_FLAT_BOX);
    fl_set_object_callback(ob,pos_cb,(long)2);
    pos->u_vdata=(void *)ob;
    if(timeout) fl_set_timer(ob, timeout); 
     

     new_h+=25;
    ok =ob= fl_add_button(FL_RETURN_BUTTON,width-ww-delta,new_h,ww,hh,yeslabel);
    fl_set_object_color(ok,upcolor, downcolor);
    /*fl_set_object_resize(ok, FL_RESIZE_NONE);*/
    /*fl_set_object_gravity(ok, FL_East, FL_NoGravity);*/
    fl_set_object_boxtype(ok,boxtype);
    fl_set_object_callback(ok,pos_cb,(long)1);
    fl_set_object_lsize(ob,fontsize);
  fl_set_object_lstyle(ob,fontstyle);
  fl_set_object_lcolor(ob,labelcolor);
   cancel=ob = fl_add_button(FL_NORMAL_BUTTON,width-ww-delta,new_h+hh+5,ww,hh,nolabel);
    fl_set_object_color(ob,upcolor, downcolor);
    /*fl_set_object_resize(ob, FL_RESIZE_NONE);*/
   /* fl_set_object_gravity(ob, FL_East, FL_NoGravity);*/
    fl_set_object_boxtype(ob,boxtype);
    fl_set_object_lsize(ob,fontsize);
  fl_set_object_lstyle(ob,fontstyle);
  fl_set_object_lcolor(ob,labelcolor);
    p=nolabel;
    while(*p && *p==*yeslabel) p++;
    if(*p)  {
     sprintf(shortcut,"#%c", *p);
     fl_set_button_shortcut(ob,shortcut,1);
     }
  fl_end_form();
  
  /*fl_set_form_minsize(form, width, height);*/
  /*fl_set_form_maxsize(form, 2*width, height);*/
  fl_show_form(form,placement,border,title);
  pos_cb(pos,0);
  while(fl_do_forms()!=cancel);

  exit(0);
}


static char  *clean(const char *);
extern int get_pixmap_dimension(const char *f, int *w, int *h){
	FILE *fp;
	char *buf, *p;
	if( (fp=fopen(f, "r"))==NULL){
			fprintf(stderr, "%s (%d) %s: %s\n",__FILE__,__LINE__,f, strerror(errno));
		return (-1);
	}
	#define LINE	512
	buf=(char *)malloc(sizeof(char)*LINE);
	while (fgets(buf, LINE, fp)){
		p=clean(buf);
		if(*p!='"' ) continue;
		p++;
		if(sscanf(p,"%d %d", w, h)<2) break;
		return 0;
	}
	fclose(fp);
	fprintf(stderr, "%s (%d) Cannot get pixmap dimension\n", 
			__FILE__,__LINE__);
	return (-1);
}

static char  *clean(const char *s)
{
	static char   *p;

	if (!s)
		return NULL;
	p = (char *)(s);
	while (*p == ' ' || *p == '\t')
		p++;
	return p;
}

