/*
 x f w i s h . c   -    m a i n   f i l e   f o r   x f w i s h , 
  			x f o r m s   w i d g e t s   f o r   t h e   s h e l l

 A u t h o r	 	: T a n o  F o t a n g
 C o p y r i g h t 	: P u b l i c   d o m a i n
 O c t o b e r		: 1 9 9 7 , r e d

 r e l e a s e  0.3.2b
Adapted for _sula_ scripts. 
http://www.geocities.com/SiliconValley/Peaks/8771

E x a m p l e s   o f  u s e :
----------------------------
see man xfwish


*/


#include "xfwish.h"
#define XFW_VERSION "0.3.2b"

typedef void Func(int, char **);
static Func *selection(void);
int     dont_close_win(FL_FORM * form, void *fdui)
{
        return FL_IGNORE;
} 

void main(int argc, char **argv){
	static int build_placement(const char *);
	static int str2cursor(const char *);
	static int str2color(const char *);
	static int str2fontsize(const char *);
	static int str2fontstyle(const char *);
	static int str2shape(const char *);
	int tmout;
	char	
		in_fontsize[16],
	     	in_fontstyle[256],
		in_bgcolor[16],
		in_fgcolor[16],
		in_border[16],
		in_placement[256],
		in_boxtype[32],
		in_downcolor[32],
		in_labelcolor[16],
		in_labelbox[16],
		in_labelstyle[256],
		in_labelsize[16],
		in_upcolor[32];


	Func *func;
	FL_CMD_OPT cmdopt[] =
	{
		{"-question", ".question", XrmoptionNoArg, "True"},
		{"-info", ".info", XrmoptionNoArg, "True"},
		{"-warning", ".warning", XrmoptionNoArg, "True"},
		{"-getfilename", ".getfilename", XrmoptionNoArg, "True"},
		{"-getvalue", ".getvalue", XrmoptionNoArg, "True"},
		{"-browsefile", ".browsefile", XrmoptionNoArg, "True"},
		{"-positioner", ".positioner", XrmoptionNoArg, "True"},
	#if 0
	 n o t   n e e d e d   b y   i r c   c l i e n t
		{"-choose", ".choice", XrmoptionNoArg, "True"},
		
		{"-counter", ".counter", XrmoptionNoArg, "True"},
		{"-dial", ".dial", XrmoptionNoArg, "True"},
		{"-slider", ".slider", XrmoptionNoArg, "True"},
		{"-select", ".select", XrmoptionNoArg, "True"}, /*single, multiple*/
		
		{"-chart", ".chart", XrmoptionNoArg, "True"},
		{"-plot", ".plot", XrmoptionNoArg, "True"},
		{"-exec", ".exec", XrmoptionNoArg, "True"},
		{"-connect", ".connect", XrmoptionNoArg, "True"},
	#endif
		/* end */
		{"-border", ".border", XrmoptionSepArg, 0},
		{"-bg", ".background", XrmoptionSepArg, 0},
		{"-fg", ".foreground", XrmoptionSepArg, 0},
		{"-fontsize", ".fontsize", XrmoptionSepArg, 0},
		{"-fontstyle", ".fontstyle", XrmoptionSepArg, 0},
		{"-boxtype",".boxtype", XrmoptionSepArg, 0}, 
		{"-upcolor",".upcolor", XrmoptionSepArg, 0},
		{"-downcolor",".downcolor", XrmoptionSepArg, 0},
		{"-labelcolor",".labelcolor", XrmoptionSepArg, 0},
		{"-labelbox",".labelbox", XrmoptionSepArg, 0},
		{"-labelfontsize",".labelfontsize", XrmoptionSepArg, 0},
		{"-labelfontstyle",".labelfontstyle", XrmoptionSepArg, 0},
		{"-geometry", ".geometry", XrmoptionSepArg, 0},
		{"-title", ".title", XrmoptionSepArg, 0},
		{"-location", ".location", XrmoptionSepArg, 0},
		{"-yeslabel", ".flQuestion.yes.label", XrmoptionSepArg, 0},
		{"-nolabel", ".flQuestion.no.label", XrmoptionSepArg, 0},
		{"-dismisslabel", ".flAlert.dismiss.label", XrmoptionSepArg, 0},
		{"-timer", "Timeout",XrmoptionSepArg, 0}


	};
	FL_resource res[] =
	{
		{"question", "QuestionCLASS", FL_BOOL, &question, "0"},
		{"warning", "WarningCLASS", FL_BOOL, &warning, "0"},
		{"info", "InfoCLASS", FL_BOOL, &information, "0"},
		{"getfilename", "GetfilenameCLASS", FL_BOOL, &getfilename, "0"},
		{"getvalue", "ValueCLASS", FL_BOOL, &getvalue, "0"},
		{"browsefile", "viewfileCLASS", FL_BOOL, &viewfile, "0"},
		{"positioner", "PositionerCLASS", FL_BOOL, &positioner, "0"},
	#if 0
	 n o t   n e e d e d   b y   i r c   c l i e n t
		{"choose", "ChoiceCLASS", FL_BOOL, &getchoice, "0"},
		{"jselect", "selCLASS", FL_BOOL, &selectt, "0"},
		{"exec", "ExecCLASS", FL_BOOL, &exec, "0"},
		{"connect", "ConnectCLASS", FL_BOOL, &server, "0"},
		
		{"counter", "CounterCLASS", FL_BOOL, &counter, "0"},
		{"dial", "DialCLASS", FL_BOOL, &dial, "0"},
		{"chart", "ChartCLASS", FL_BOOL, &chart, "0"},
		{"plot", "PlotCLASS", FL_BOOL, &plot, "0"},
		{"slider", "SliderCLASS", FL_BOOL, &slider, "0"},
	#endif
		{"boxtype","BoxtypeCLASS", FL_STRING,in_boxtype,"up_box",31},
		{"downcolor","dButtonCLASS", FL_STRING,in_downcolor,"green",31},
		{"upcolor","uButtonCLASS", FL_STRING,in_upcolor,"0",31},
		{"labelcolor","LabelCLASS", FL_STRING,in_labelcolor,"black",15},
		{"labelbox","LabelCLASS", FL_STRING,in_labelbox,"flat_box",15},
		{"labelfontstyle","LabelCLASS", FL_STRING,in_labelstyle,"0",255},
		{"labelfontsize","LabelCLASS", FL_STRING,in_labelsize,"0",15},
		{"background", "BgCLASS", FL_STRING, in_bgcolor, "0", 15},
		{"foreground", "FgCLASS", FL_STRING, in_fgcolor, "0", 15},
		{"fontsize", "FontCLASS", FL_STRING, in_fontsize, "normal", 15},
		{"fontstyle", "FontCLASS", FL_STRING, in_fontstyle, "bold", 255},
		{"geometry", "GeometryCLASS", FL_STRING, geometry, "0x0", 15},
		{"title", "TitleCLASS", FL_STRING, title, "xfwish "XFW_VERSION, 255},
		{"border","BorderCLASS",FL_STRING,in_border, "transient",15},
		{"location", "LocationCLASS", FL_STRING, in_placement, "mouse", 255},
		{"flQuestion.yes.label", "LabelCLASS", FL_STRING, yeslabel, "Ok", 15},
		{"flQuestion.no.label", "LabelCLASS", FL_STRING, nolabel, "Cancel", 15},
		{"flAlert.dismiss.label", "LabelCLASS", FL_STRING, dismisslabel, "Dismiss", 15},
		{"Timeout", "TimeoutCLASS", FL_INT, &tmout,"360"}
	};


	fl_set_border_width(-1);
	fl_initialize(&argc, argv, "xfwish", cmdopt, sizeof(cmdopt)/sizeof(FL_CMD_OPT));
	fl_get_app_resources(res, sizeof(res)/sizeof(FL_resource));
	if(!strcmp(argv[0],"xfwask")) question=1;
	else if(!strcmp(argv[0],"xfwwarn")) warning=1;
	else if(!strcmp(argv[0],"xfwinfo")) information=1;
	else if(!strcmp(argv[0],"xfwinput")) getvalue=1;
	else if(!strcmp(argv[0],"xfwfile")) getfilename=1;
	else if(!strcmp(argv[0],"xfwbrowse")) viewfile=1;
	else if(!strcmp(argv[0],"xfwpos")) positioner=1;
	if(!(func=selection())){
	#ifdef SULA
		exit(-1);
	#else
		fprintf(stderr, "%s Error: you must specify a widget type.\n",argv[0]);
		exit(-1);
	#endif
	}else{
		timeout=(double)tmout;
		#define FL_GRAY	FL_COL1
		if( (bgcolor = str2color(in_bgcolor))==-1) bgcolor= FL_GRAY;
		if( (fgcolor = str2color(in_fgcolor))==-1) fgcolor=FL_BLACK;
		if( (labelcolor = str2color(in_labelcolor))==-1) labelcolor=FL_BLACK;
		if( (downcolor = str2color(in_downcolor))==-1) downcolor=FL_GRAY;
		if( (upcolor = str2color(in_upcolor))==-1) upcolor=FL_COL1/*MCOL*/;
		if( (boxtype=str2shape(in_boxtype))==-1) boxtype=FL_UP_BOX;
		if( (labelboxtype=str2shape(in_labelbox))==-1) labelboxtype=FL_UP_BOX;
		if( (fontsize = str2fontsize(in_fontsize))==-1) fontsize=FL_NORMAL_SIZE;
		if( (labelfontsize = str2fontsize(in_labelsize))==-1) labelfontsize=FL_NORMAL_SIZE;
		if( (fontstyle = str2fontstyle(in_fontstyle))==-1) fontstyle=FL_ITALIC_STYLE;
		if( (labelfontstyle = str2fontstyle(in_labelstyle))==-1) labelfontstyle=FL_NORMAL_STYLE;;
		strcpy(yeslabel, buildstr(yeslabel));
		strcpy(nolabel,buildstr(nolabel));
		strcpy(dismisslabel,buildstr(dismisslabel));
		placement = build_placement(in_placement);
		if(!strcasecmp(in_border,"transient")) border=FL_TRANSIENT;
		else if(!strcasecmp(in_border,"fullborder")) border=FL_FULLBORDER;
		else border=FL_NOBORDER;
		width=height=0;
		sscanf(geometry, "%d%*[ *xX]%d",&width, &height);
		(*func)(argc, argv);/* should not return*/
	}
}

static Func *selection(void){

	typedef struct TSel{
		int *what;
		Func *func; 
		/*void (*func)(int, char **);*/
	}Sel;
	Sel task[]={
		/*{&message, &do_confirm},*/
		{&question, &do_confirm},
		{&information, &do_confirm},
		{&warning, &do_confirm},
		{&getfilename, &do_getfname},
		{&getvalue, &do_getstring},
		{&viewfile, &do_browsefile},
		{&positioner,&do_positioner},
	#if 0
	n o t   n e e d e d   h e r e
		{&getchoice, &do_choose},
		
		{&counter, &do_counter},
		{&dial,&do_dial},
		{&slider, &do_slider},
		{&selectt, &do_select},
		
		{&chart, &do_chart},
		{&plot, &do_plot},
		{&exec, &do_exec},
		{&server, &do_connect},
	#endif
		{NULL,NULL}
	};
	Sel *p=task;
	while(p->func)
 		if(*(p->what)) return p->func; else p++;
	return NULL;
}

typedef struct TAttrib {
	char *name;
	 int value;
 } Attrib;

 static int find_attrib(Attrib * p, const char *var, int n) {
	 register int low, high, mid, cond;
	 low = 0; high = n - 1;
	 while (low <= high) {
	 mid = (low + high) / 2;
	 /*if ((cond = strncasecmp(var,(p + mid)->name, strlen(var))) < 0)*/
	 if ((cond = strcasecmp(var,(p + mid)->name)) < 0)
	 high = mid - 1;
	 else
	 if (cond > 0)
	 low = mid + 1;
	 else
	 return mid;
	 }
	 return -1;
 }


 static int build_placement(const char *pos) {

 Attrib placement[] = {
 { "aspect", FL_PLACE_ASPECT },
 { "center", FL_PLACE_CENTER },
 { "centerfree", FL_PLACE_CENTERFREE },
 { "free", FL_PLACE_FREE },
 { "freesize", FL_FREE_SIZE },
{"fullscreen", FL_PLACE_FULLSCREEN },
{ "geometry", FL_PLACE_GEOMETRY	 },
{ "hotspot", FL_PLACE_HOTSPOT },
 { "iconic", FL_PLACE_ICONIC },
 { "mouse", FL_PLACE_MOUSE }
 };

int loc = 0;
char *pp, *p;
 char tmp[256];
 Attrib * pl = placement;
 int entries = sizeof(placement) / sizeof(Attrib);

 if (!pos) return FL_PLACE_MOUSE;
 pp = tmp;
 p = (char *) pos;
 while (*p) {
	 int i;
	 while ((*pp = *p++) && (*pp != '+'))
	 	if(*pp==' ' || *pp=='\t') continue;
		else pp++;
	 if (*pp == '+') * pp = '\0';
	 i = find_attrib(pl, tmp, entries);
	 if (i > -1) loc |= placement[i].value;
	 pp = tmp;
 }
 return (loc ? loc : FL_PLACE_MOUSE);
 }
 

#if 0
      const char *counter_int_filter(FL_OBJECT * ob, double val, int prec) {
		 static char buf[32];

		 sprintf(buf, "%d", (int) val);
		 return buf;
		 }
#endif


 int str2color(const char *str) {

 Attrib wfl_color[] = {
 		{
 		"bcol", FL_TOP_BCOL
	 	},
		 {
		 "black", FL_BLACK
		 },
		 {
		 "blue", FL_BLUE
		 },
		 {
		 "bottom_bcol", FL_BOTTOM_BCOL
		 },
		 {
		 "cyan", FL_CYAN
		 },
		 {
		 "darkcyan", FL_DARKCYAN
		 },
		 {
		 "darkgold", FL_DARKGOLD
		 },
		 {
		 "darktomato", FL_DARKTOMATO
		 },
		 {
		 "gray", FL_COL1
		 },
		 {
		 "green", FL_GREEN
		 },
		 {
		 "grey", FL_COL1
		 },
		 {
		 "inactive_col", FL_INACTIVE_COL
		 },
		 {
		 "indianred", FL_INDIANRED
		 },
		 {
		 "left_bcol", FL_LEFT_BCOL
		 },
		 {
		 "magenta", FL_MAGENTA
		 },
		 {
		 "mcol", FL_MCOL
		 },
		 {
		 "orchid", FL_ORCHID
		 },
		 {
		 "palegreen", FL_PALEGREEN
		 },
		 {
		 "red", FL_RED
		 },
		 {
		 "right_bcol", FL_RIGHT_BCOL
		 },
		 {
		 "slateblue", FL_SLATEBLUE
		 },
		 {
		 "tomato", FL_TOMATO
		 },
		 {
		 "wheat", FL_WHEAT
		 },
		 {
		 "white", FL_WHITE
		 },
		 {
		 "yellow", FL_YELLOW
		 }
		 };
		 Attrib * p = wfl_color;

		 int i;
		 if(!strcasecmp(str,"0")) return (-1);
	    i = find_attrib(p, str, sizeof(wfl_color) / sizeof(Attrib));
		 if (i < 0) {
#ifndef SULA
		 fprintf(stderr, "%s (%d) Unknown colour name: %s\n", __FILE__, __LINE__, str);
#endif
		 return (-1);
		 }
		 else
		 return wfl_color[i].value;

		 }

static int str2fontsize(const char *str) {
Attrib fontsizes[]={
	{"huge",FL_HUGE_SIZE},
	{"large", FL_LARGE_SIZE},
	{"medium",FL_MEDIUM_SIZE},
	{"normal",FL_NORMAL_SIZE},
	{"small",FL_SMALL_SIZE},
	{"tiny",FL_TINY_SIZE}
};
Attrib *p=fontsizes;
int i;
if(!strcasecmp(str,"0")) return (-1);
i=find_attrib(p, str, sizeof(fontsizes) / sizeof(Attrib));
if(i>-1) return fontsizes[i].value;
#ifndef SULA
	fprintf(stderr, "%s (%d) Unknown font size: %s\n", __FILE__, __LINE__, str);
#endif
   return FL_NORMAL_SIZE;
  }

static int str2shape(const char *str) {
Attrib boxtypes[]={
        {"border_box", FL_BORDER_BOX},
        {"down_box",FL_DOWN_BOX},
        {"embossed_box",FL_EMBOSSED_BOX},
        {"flat_box",FL_FLAT_BOX},
        {"frame_box",FL_FRAME_BOX},
        {"no_box",FL_NO_BOX},
        {"oval3d_downbox",FL_OVAL3D_DOWNBOX},
        {"oval3d_upbox",FL_OVAL3D_UPBOX},
        {"oval_box",FL_OVAL_BOX},
        {"rounded3d_downbox",FL_ROUNDED3D_DOWNBOX},
        {"rounded3d_upbox",FL_ROUNDED3D_UPBOX},
        {"rounded_box",FL_ROUNDED_BOX},
        {"roundedflat_box",FL_RFLAT_BOX},
        {"roundedshadow_box",FL_RSHADOW_BOX},
        {"shadow_box",FL_SHADOW_BOX},
        {"up_box",FL_UP_BOX}
};
Attrib *p=boxtypes;
int i;
/* return FL_UP_BOX;*/
if(!strcasecmp(str,"0")) return (-1);
i=find_attrib(p, str, sizeof(boxtypes) / sizeof(Attrib));
if(i>-1) return boxtypes[i].value;
fprintf(stderr, "%s (%d) Unknown box type: %s\n", __FILE__, __LINE__, str);
  return FL_UP_BOX;
  }

static   int str2fontstyle(const char *str) {

	Attrib fontstyles[] = {
		 {
	 "bold", FL_BOLD_STYLE
		 },
		 {
	 "bolditalic", FL_BOLDITALIC_STYLE
		 },
		 {
	 "embossed", FL_EMBOSSED_STYLE
		 },
		 {
	 "engraved", FL_ENGRAVED_STYLE
		 },
		 {
	 "fixed", FL_FIXED_STYLE
		 },
		 {
	 "fixedbold", FL_FIXEDBOLD_STYLE
		 },
		 {
	 "fixedbolditalic", FL_FIXEDBOLDITALIC_STYLE
		 },
		 {
	 "fixeditalic", FL_FIXEDITALIC_STYLE
		 },
		 {
	 "italic", FL_ITALIC_STYLE
		 },
		 {
	 "normal", FL_NORMAL_STYLE
		 },
		 {
	 "shadow", FL_SHADOW_STYLE
		 },
		 {
	 "times", FL_TIMES_STYLE
		 },
		 {
	 "timesbold", FL_TIMESBOLD_STYLE
		 },
		 {
	 "timesbolditalic", FL_TIMESBOLDITALIC_STYLE
		 },
		 {
	 "timesitalic", FL_TIMESITALIC_STYLE
		 }
	 };

	 int fstyle = 0;
	 char *pp, *p;
	 char tmp[256];
	 Attrib * fs = fontstyles;
	 int entries = sizeof(fontstyles) / sizeof(Attrib);

	 if(!strcasecmp(str,"0")) return (-1);
	 pp = tmp;
	 p = (char *) str;
	 while (*p) {
		 int i;
		 while ((*pp = *p++) && (*pp != '+'))
		 	if(*pp==' ' || *pp=='\t') continue; 
			else pp++;
		 if (*pp == '+') * pp = '\0';
		 i = find_attrib(fs, tmp, entries);
		 if (i > -1) fstyle |= fontstyles[i].value;
#ifndef SULA
		 else
		 fprintf(stderr, "%s (%d) Unknown font style: %s\n", __FILE__, __LINE__, tmp);
#endif
		 pp = tmp;
		 }
	 return (fstyle ? fstyle : FL_BOLD_STYLE);
 }


extern  int set_cursor(FL_OBJECT * ob, int event,
		   FL_Coord mx, FL_Coord my, int key, void *xev)
{
	switch (event) {
	    case FL_ENTER:
		    /*if(XC_xterm== (int)ob->u_ldata) puts("okay");
		    else puts("w");  */
		    fl_set_cursor(FL_ObjWin(ob), ob->u_ldata);
		    return !FL_PREEMPT;
		    break;
	    case FL_LEAVE:
		    fl_reset_cursor(FL_ObjWin(ob));
		    return !FL_PREEMPT;
		    break;
	    default:
		    return !FL_PREEMPT;
	}
}

char   *strsstr(const char *s1, const char *s2)
{
	static char   *t;

	if (!s1 || !(*s1))
		return NULL;
	t = strstr(s1, s2);
	if (t)
		return (t + strlen(s2));
	else
		return NULL;
}
char *buildstr(const char *msg){
	static char *s;
	char *p;
	if(!msg) return NULL;
	s=(char *)malloc(sizeof(char)*(strlen(msg)+16));
	if(!s) return NULL;
	p=s;
	while(*p=*msg++) 
		if(*p=='%' && *msg=='/'){
			*p++='\n'; msg++;
		}else p++;
	return s;
}

